require "amrita2/template"
include Amrita2
include Amrita2::Runtime

tmpl = TemplateText.new <<END
<html>
   <body>
      <h1 id='title' />
      <table>
      <tr>
        <th>name</th>
        <th>author</th>
        <th>website</th>
      </tr>
      <tr id='languages'>
         <td id='name' />
         <td id='author' />
         <td id='website'><![CDATA[ 
            <a href="<%= $_.url %>"><%= $_.name  %></a>
         ]]></td>
      </tr>
      </table>
   </body>
</html>
END

tmpl.use_erb(binding)

Lang = Struct.new(:name, :author, :website)
WebSite = Struct.new(:name, :url)

data = {
  :title => 'Amrita2 with ERB',
  :languages=>[ 
      Lang.new("Ruby", "matz", WebSite.new('Ruby Home Page', 'http://www.ruby-lang.org/')),
      Lang.new("Perl", "Larry Wall", WebSite.new('The Source for Perl', 'http://perl.com/')),
      Lang.new("Python","Guido van Rossum", WebSite.new('Python Programing Language', 'http://www.python.org/'))
  ]
}

tmpl.expand(STDOUT, data)

__END__
<html>
   <body>
      <h1>Amrita2 with ERB</h1>
      <table>
      <tr>
        <th>name</th>
        <th>author</th>
        <th>website</th>
      </tr>
      <tr>
         <td>Ruby</td>
         <td>matz</td>
         <td> 
            <a href="http://www.ruby-lang.org/">Ruby Home Page</a>
         </td>
      </tr><tr>
         <td>Perl</td>
         <td>Larry Wall</td>
         <td> 
            <a href="http://perl.com/">The Source for Perl</a>
         </td>
      </tr><tr>
         <td>Python</td>
         <td>Guido van Rossum</td>
         <td> 
            <a href="http://www.python.org/">Python Programing Language</a>
         </td>
      </tr>
      </table>
   </body>
</html>
