require "amrita2/template"
include Amrita2
include Amrita2::Runtime # for amrita:type='erb'

TEMPLATE_TEXT = <<END
<html>
   <head>
     <title id='header_title' />
   </head>
   <body>
      <amrita:erb id='title'>
        <h1><%= TITLE + $_[:text] %></h1>
      </amrita:erb>
      <table>
      <tr><th>name</th><th>author</th></tr>
      <span id='item'><![CDATA[
        <tr>
          <td><%= make_link($_.url, $_.name) %></td>
          <td><%= $_.author %></td>
        </tr>
      ]]></span>
      </table>
      <hr />
      <br />
</body>
</html>
END

Lang = Struct.new(:name, :url, :author)

table = [
  Lang.new("Ruby", "http://www.ruby-lang.org/", "Matz"),
  Lang.new("Perl", "http://www.perl.com/",  "Larry Wall"),
  Lang.new("Python", "http://www.python.org/", "Guido van Rossum")
]

tmpl = TemplateText.new(TEMPLATE_TEXT) 

def make_link(url, text)
  "<a href='#{url}'>#{text}</a>"
end
TITLE='Amrita2 with ERB '

# get binding at the place where you can see 'make_link' and 'TITLE '
tmpl.use_erb(binding)

data = { 
  :header_title => TITLE,
  :title => { :text=> ' Sample'}, 
  :item=> table
}
tmpl.expand(STDOUT, data)

__END__
<html>
   <head>
     <title>Amrita2 with ERB </title>
   </head>
   <body>
        <h1>Amrita2 with ERB  Sample</h1>
      <table>
      <tr><th>name</th><th>author</th></tr>
        <tr>
          <td><a href='http://www.ruby-lang.org/'>Ruby</a></td>
          <td>Matz</td>
        </tr>
        <tr>
          <td><a href='http://www.perl.com/'>Perl</a></td>
          <td>Larry Wall</td>
        </tr>
        <tr>
          <td><a href='http://www.python.org/'>Python</a></td>
          <td>Guido van Rossum</td>
        </tr>
      </table>
      <hr></hr>
      <br></br>
</body>
</html>
