
require 'test/unit'
require 'test/unit/testsuite'
require 'test/unit/ui/console/testrunner'
require 'amrita2/template'
require 'net/http'
require 'yaml'

# ruby -I~/amrita2_core/lib ~/amrita2_core/test/test_rails.rb   |ruby -pe '$_.sub!(/^ */, "") ' 

=begin 
# CAUTION: THIS IS NOT SECURE!!
#          If you want to run this script on an important machine,
#          consult your db admin
#
# you need this before running this script
#
# mysql -u root -p
mysql> grant all on *.* to amrita2test@localhost identified by 'a' ;

# mysql -u amrita2test -p

-- http://darkhost.mine.nu:81/~vince/rails/tutorial.html
-- Create the database
CREATE DATABASE `amrita2_test` ;
USE amrita2_test ;
-- Create the table
CREATE TABLE `todos` (
  `id` INT NOT NULL AUTO_INCREMENT ,
  `description` VARCHAR( 100 ) NOT NULL ,
  `done` TINYINT DEFAULT '0' NOT NULL ,
  PRIMARY KEY ( `id` )
);


-- from http://wiki.rubyonrails.com/rails/show/TutorialStepOne
CREATE TABLE `people` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `street1` varchar(70) NOT NULL default '',
  `street2` varchar(70) NOT NULL default '',
  `city` varchar(70) NOT NULL default '',
  `state` char(2) NOT NULL default '',
  `zip` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;
INSERT INTO `people` VALUES (1, 'Superman', '123 Somewhere', '', 'Smallville', 'KS', '123456');

CREATE TABLE `phones` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `person_id` int(10) unsigned NOT NULL default '0',
  `phone` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `people_id` (`person_id`),
  KEY `phone` (`phone`)
) TYPE=MyISAM;
INSERT INTO `phones` VALUES (1, 1, '1234567890');
INSERT INTO `phones` VALUES (2, 1, '1122334455');
=end

class RailsEnvironment
  AMRITA2_ROOT=File::expand_path("~/amrita2_core")
  TMPDIR="/tmp/railstest#$$"
  PORT=13000
  USER='amrita2test'
  PASS='a'

  def initialize
    system "rm -rf #{TMPDIR}"
    Dir::mkdir(TMPDIR)
    trap('EXIT') do
      system "rm -rf #{TMPDIR}"
    end
  end

  def setup_for(prj,apppath)
    # make project root directory
    Dir::mkdir(TMPDIR) unless FileTest::directory?(TMPDIR)
    dir = "#{TMPDIR}/#{prj}"
    system "rm -rf #{dir}"
    Dir::mkdir(dir)

    # run 'rails' command to make application skelton
    system "rails #{dir} > /dev/null"

    # link amrita2/lib to the project lib directory
    File.symlink "#{AMRITA2_ROOT}/lib/amrita2", "#{dir}/lib/amrita2"

    setup_database(dir)
    
    # link the sample application to the project
    system "rm -rf #{dir}/app"
    File.symlink "#{AMRITA2_ROOT}/#{apppath}", "#{dir}/app"

    setup_env(dir)

    dir
  end

  # run the 'script/server' command in this process
  def start(prj)
    dir = "#{TMPDIR}/#{prj}"
    @pid = fork do 
      Dir::chdir(dir)
      exec "ruby script/server -p #{PORT}"
    end
    10.times do
      begin
        do_get('/')
        break
      rescue
        #p $!
        sleep 1
      end
    end
  end

  # stop the webrick rails server and clear the Configuratio
  def stop(prj)
    #Process.kill('TERM', @pid)
    return unless @pid
    Process.kill('KILL', @pid) 
    Process.wait
  end

  # set the database environment for rails
  def setup_database(dir)
    path = "#{dir}/config/database.yml"
    File::open(path, "w") do |f|
      f.puts <<-END
      development:
        adapter: mysql
        database: amrita2_test
        host: localhost
        socket: /var/run/mysqld/mysqld.sock
        username: #{USER}
        password: #{PASS}
      END
    end
  end

  # set the delegator for amrita2 template
  def setup_env(dir)
    path = "#{dir}/config/environment.rb"
    File::open(path, "a") do |f|
      f.puts <<-END

      require 'amrita2/rails_bridge'
      ActionView::Base.register_template_handler "a2html", Amrita2View::Base
      END
    end
  end


  def do_get(path)
    Net::HTTP.start('localhost', PORT) do |http|
      response = http.get(path)
      res = response.body
      return res
    end
  end

  def with_rails(prj, apppath, &block)
    dir = setup_for(prj, apppath)
    start(prj)
    block.call(self, dir)
  ensure
    stop(prj)
  end
end

module Amrita2RailsTest
  include Amrita2
  include Amrita2::Core
  ENV=RailsEnvironment.new

  class TestWithAR < Test::Unit::TestCase
    include Amrita2
    require 'rubygems'
    require 'active_record'
    class Todo < ActiveRecord::Base
      def self.find_not_done
        find_all("done = 0", "description")
      end

      def self.find_done
        find_all("done = 1", "description")
      end
    end

    class Person < ActiveRecord::Base
      def self.table_name()
        "people" 
      end
      has_many :phones
    end

    class Phone < ActiveRecord::Base
    end

    def setup
      para = {
        'adapter'=>'mysql', 
        'database'=>'amrita2_test', 
        'host'=>'localhost', 
        'username'=>RailsEnvironment::USER, 
        'password'=>RailsEnvironment::PASS,
        'socket'=> '/var/run/mysqld/mysqld.sock'
      }
      ActiveRecord::Base.establish_connection(para)

      Todo.destroy_all
      Todo.create "description" => "testdata1"
      Todo.create "description" => "testdata2"
      Todo.create "description" => "donexx", 'done'=> '1'

      Person.destroy_all
      Phone.destroy_all
      g = Person.create 'name' => 'Goku'
      phone =g.build_to_phones
      phone.phone='111-1111'
      phone.save
      phone =g.build_to_phones
      phone.phone='111-2222'
      phone.save
      k = Person.create 'name' => 'Krillin'
      phone =k.build_to_phones
      phone.phone='222-1111'
      phone.save
      Person.create 'name' => 'Vegeta'
    end

    def test_ar1
      t = TemplateText.new <<-END
      <span id='aaa' amrita:type='expand_by_member' amrita:option=':delete_tag=>true'>
        <span id='description'  amrita:option=':delete_tag=>true'/>
      </span> 
      END
      t.expand(out="", :aaa=>Todo.find_all) 
      assert_equal(%w(donexx testdata2 testdata1), out.split)
    end

    def test_ar2
      t = TemplateText.new <<-END
      <ul>
        <li id='person'  amrita:type='expand_by_member'>
        Name: <span id='name' /><br />
        phones(
        <span id='phones'  amrita:type='expand_by_member' amrita:option=':delete_tag=>true'>
           <span id='phone'  amrita:option=':delete_tag=>true' />
        </span>)
        </li>
      </ul> 
      END
      data = Person.find_all(nil, 'name')
      t.expand(out="", :person=>data)
      result = `echo '#{out}'|env LANG=C w3m -T text/html`
      # print result
      assert_equal(<<-END, result)
  * Name: Goku
    phones( 111-2222 111-1111 )
  * Name: Krillin
    phones( 222-1111 )
  * Name: Vegeta
    phones( )

END
    end
  end

  class TestWithRails < Test::Unit::TestCase
    def setup_todo_data(dir)
      require 'rubygems'
      require 'active_record'
      opt = YAML::load(File::open("#{dir}/config/database.yml").read)
      ActiveRecord::Base.establish_connection(opt['development'])

      todopath = "#{dir}/app/models/todo.rb"
      load todopath
      Todo.find_all.each do |t|
        t.destroy
      end
      Todo.create "description" => "test data 1"
      Todo.create "description" => "test data 2"
      Todo.create "description" => "donexx", 'done'=> '1'
      Todo.find_all.each do |t|
        #p t
      end
    end

    def test_sample
      ENV.with_rails('sample', 'sample/rails/sample') do |e, dir|
        assert(e.do_get('/'))
        l = e.do_get('/hello/')
        #puts l
        root = REXML::Document.new(l).root
        assert_equal('Hello ROR with Amrita2', root.elements['body/h1'].text)
        assert_equal('hello world', root.elements['body/ul/li/a'].text)
        assert_equal('index', root.elements['body/ul/li/a'].attributes['href'])

        l = e.do_get('/hello/languages')
        #puts l
        root = REXML::Document.new(l).root
        assert_equal('http://www.ruby-lang.org/', root.elements['body/table/tr/td/a'].attributes['href'])
        assert_equal('Ruby', root.elements['body/table/tr/td/a'].text)

      end
    end

    def test_todo1
      ENV.with_rails('todo1', 'sample/rails/todoapp1') do |e, dir|
        setup_todo_data(dir)
        assert(e.do_get('/'))
        l = e.do_get('/todo/list')
        #puts l
        assert_match(/test data 1/, l)
        assert_match(/test data 2/, l)
        assert_match(/donexx/, l)
      end
    end

    def test_todo2
      ENV.with_rails('todo2', 'sample/rails/todoapp2') do |e, dir|
        setup_todo_data(dir)
        #puts e.do_get('/')
        assert(e.do_get('/'))
        l = e.do_get('/todo/list')
        doc = REXML::Document.new(l)
        not_done1, not_done2, done = *doc.root.elements.to_a('body/div')
        assert_match(/test data 1/, not_done1.to_s)
        assert_match(/test data 2/, not_done2.to_s)
        assert_match(/donexx/, done.to_s)
      end
    end
  end
end

if __FILE__ == $0
  include Amrita2RailsTest
  cname = ARGV.shift
  if cname
    method = ARGV.shift
    if method
      eval "Test::Unit::UI::Console::TestRunner.run(#{cname}.new(\"#{method}\"))"
    else
      cls = eval(cname)
      Test::Unit::UI::Console::TestRunner.run(cls)
    end
  else
    suite = Test::Unit::TestSuite.new
    suite << TestWithAR.suite
    suite << TestWithRails.suite
    Test::Unit::UI::Console::TestRunner.run(suite)
  end
end
